angular.module('mnJsonTablesCell', ['mnCollapsibleText']).directive('mnJsonTablesCell', function ($compile) {

  return {
    restrict: 'A',
    scope: {
      mnJsonTablesCell: '='
    },
    templateUrl: '/components/directives/mn_json_tables/mn_json_tables_cell.html',
    compile: function (tElement, tAttr, transclude) {
      //We are removing the contents/innerHTML from the element we are going to be applying the
      //directive to and saving it to adding it below to the $compile call as the template
      //This is workaround for recursive templates
      var contents = tElement.contents().remove();
      var compiledContents;
      return function (scope, iElement, iAttr) {
        if (!compiledContents) {
          compiledContents = $compile(contents, transclude);
        }
        compiledContents(scope, function(clone, scope) {
          iElement.append(clone);
        });
      };
    },
    controller: function ($scope) {
      $scope._ = _;
      $scope.trackByTopLevelObjectAndIndex = function ($index, value) {
        return $index + '-' + JSON.stringify(value, function (k, v) {
          return _.isPlainObject(v) && !!k ? undefined : v
        });
      };
    }
  };
});